// Code generated by go-swagger; DO NOT EDIT.

package azure

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/vmware-tanzu/tanzu-framework/pkg/v1/tkg/web/server/models"
)

// GetAzureRegionsReader is a Reader for the GetAzureRegions structure.
type GetAzureRegionsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAzureRegionsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAzureRegionsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewGetAzureRegionsBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 401:
		result := NewGetAzureRegionsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetAzureRegionsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetAzureRegionsOK creates a GetAzureRegionsOK with default headers values
func NewGetAzureRegionsOK() *GetAzureRegionsOK {
	return &GetAzureRegionsOK{}
}

/*GetAzureRegionsOK handles this case with default header values.

Successful retrieval of Azure regions
*/
type GetAzureRegionsOK struct {
	Payload []*models.AzureLocation
}

func (o *GetAzureRegionsOK) Error() string {
	return fmt.Sprintf("[GET /api/providers/azure/regions][%d] getAzureRegionsOK  %+v", 200, o.Payload)
}

func (o *GetAzureRegionsOK) GetPayload() []*models.AzureLocation {
	return o.Payload
}

func (o *GetAzureRegionsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAzureRegionsBadRequest creates a GetAzureRegionsBadRequest with default headers values
func NewGetAzureRegionsBadRequest() *GetAzureRegionsBadRequest {
	return &GetAzureRegionsBadRequest{}
}

/*GetAzureRegionsBadRequest handles this case with default header values.

Bad Request
*/
type GetAzureRegionsBadRequest struct {
	Payload *models.Error
}

func (o *GetAzureRegionsBadRequest) Error() string {
	return fmt.Sprintf("[GET /api/providers/azure/regions][%d] getAzureRegionsBadRequest  %+v", 400, o.Payload)
}

func (o *GetAzureRegionsBadRequest) GetPayload() *models.Error {
	return o.Payload
}

func (o *GetAzureRegionsBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAzureRegionsUnauthorized creates a GetAzureRegionsUnauthorized with default headers values
func NewGetAzureRegionsUnauthorized() *GetAzureRegionsUnauthorized {
	return &GetAzureRegionsUnauthorized{}
}

/*GetAzureRegionsUnauthorized handles this case with default header values.

Incorrect credentials
*/
type GetAzureRegionsUnauthorized struct {
	Payload *models.Error
}

func (o *GetAzureRegionsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /api/providers/azure/regions][%d] getAzureRegionsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetAzureRegionsUnauthorized) GetPayload() *models.Error {
	return o.Payload
}

func (o *GetAzureRegionsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAzureRegionsInternalServerError creates a GetAzureRegionsInternalServerError with default headers values
func NewGetAzureRegionsInternalServerError() *GetAzureRegionsInternalServerError {
	return &GetAzureRegionsInternalServerError{}
}

/*GetAzureRegionsInternalServerError handles this case with default header values.

Internal server error
*/
type GetAzureRegionsInternalServerError struct {
	Payload *models.Error
}

func (o *GetAzureRegionsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /api/providers/azure/regions][%d] getAzureRegionsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetAzureRegionsInternalServerError) GetPayload() *models.Error {
	return o.Payload
}

func (o *GetAzureRegionsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
