// Code generated by go-swagger; DO NOT EDIT.

package vsphere

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/vmware-tanzu/tanzu-framework/pkg/v1/tkg/web/server/models"
)

// GetVSphereDatacentersReader is a Reader for the GetVSphereDatacenters structure.
type GetVSphereDatacentersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetVSphereDatacentersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetVSphereDatacentersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewGetVSphereDatacentersBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 401:
		result := NewGetVSphereDatacentersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetVSphereDatacentersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetVSphereDatacentersOK creates a GetVSphereDatacentersOK with default headers values
func NewGetVSphereDatacentersOK() *GetVSphereDatacentersOK {
	return &GetVSphereDatacentersOK{}
}

/*GetVSphereDatacentersOK handles this case with default header values.

Successful retrieval of vSphere datacenters
*/
type GetVSphereDatacentersOK struct {
	Payload []*models.VSphereDatacenter
}

func (o *GetVSphereDatacentersOK) Error() string {
	return fmt.Sprintf("[GET /api/providers/vsphere/datacenters][%d] getVSphereDatacentersOK  %+v", 200, o.Payload)
}

func (o *GetVSphereDatacentersOK) GetPayload() []*models.VSphereDatacenter {
	return o.Payload
}

func (o *GetVSphereDatacentersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetVSphereDatacentersBadRequest creates a GetVSphereDatacentersBadRequest with default headers values
func NewGetVSphereDatacentersBadRequest() *GetVSphereDatacentersBadRequest {
	return &GetVSphereDatacentersBadRequest{}
}

/*GetVSphereDatacentersBadRequest handles this case with default header values.

Bad request
*/
type GetVSphereDatacentersBadRequest struct {
	Payload *models.Error
}

func (o *GetVSphereDatacentersBadRequest) Error() string {
	return fmt.Sprintf("[GET /api/providers/vsphere/datacenters][%d] getVSphereDatacentersBadRequest  %+v", 400, o.Payload)
}

func (o *GetVSphereDatacentersBadRequest) GetPayload() *models.Error {
	return o.Payload
}

func (o *GetVSphereDatacentersBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetVSphereDatacentersUnauthorized creates a GetVSphereDatacentersUnauthorized with default headers values
func NewGetVSphereDatacentersUnauthorized() *GetVSphereDatacentersUnauthorized {
	return &GetVSphereDatacentersUnauthorized{}
}

/*GetVSphereDatacentersUnauthorized handles this case with default header values.

Incorrect credentials
*/
type GetVSphereDatacentersUnauthorized struct {
	Payload *models.Error
}

func (o *GetVSphereDatacentersUnauthorized) Error() string {
	return fmt.Sprintf("[GET /api/providers/vsphere/datacenters][%d] getVSphereDatacentersUnauthorized  %+v", 401, o.Payload)
}

func (o *GetVSphereDatacentersUnauthorized) GetPayload() *models.Error {
	return o.Payload
}

func (o *GetVSphereDatacentersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetVSphereDatacentersInternalServerError creates a GetVSphereDatacentersInternalServerError with default headers values
func NewGetVSphereDatacentersInternalServerError() *GetVSphereDatacentersInternalServerError {
	return &GetVSphereDatacentersInternalServerError{}
}

/*GetVSphereDatacentersInternalServerError handles this case with default header values.

Internal server error
*/
type GetVSphereDatacentersInternalServerError struct {
	Payload *models.Error
}

func (o *GetVSphereDatacentersInternalServerError) Error() string {
	return fmt.Sprintf("[GET /api/providers/vsphere/datacenters][%d] getVSphereDatacentersInternalServerError  %+v", 500, o.Payload)
}

func (o *GetVSphereDatacentersInternalServerError) GetPayload() *models.Error {
	return o.Payload
}

func (o *GetVSphereDatacentersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
